#INCLUDE "dcdialog.CH"
#INCLUDE "dcgraph.CH"
#INCLUDE "dcprint.CH"

FUNCTION Main()

LOCAL GetList[0], GetOptions, oRmChart, oRegion1, oRegion2, oRegion3, ;
      oRegion4, oRegion5, oRegion6, aBarGroup[0], aLineGroup[0], aPie[0], ;
      aDonut[0], aBarGroupFloat[0], aBarGroupIndus[0], aLineGroupIndus[0], ;
      aDataAxis1[0], aDataAxis5[0], aDataAxis6[0], aLabelText, cRegSvr, ;
      cRmChart, cClsId, cRegQuery, aData, nWhich, oStatus

// cClsId := '\CLSID\{8E2EA06D-6ACA-4E52-9D5D-3CE2A89A15BE}'    // RMChart Version 3.xx
   cClsId := '\CLSID\{4D814D0F-7D71-4E7E-B51E-2885AD0ED9D7}'    // RMChart Version 4.xx

DC_DefDir(DC_CurPath()+'\')

cRegSvr := 'regsvr32.exe'

cRegQuery := DC_RegQuery(HKEY_CLASSES_ROOT,cClsId,'')
IF Valtype(cRegQuery) # 'C' .OR. Empty(cRegQuery)
  RunShell('rmchart.ocx /s',cRegSvr)
  cRegQuery := DC_RegQuery(HKEY_CLASSES_ROOT,cClsId,'')
  IF Valtype(cRegQuery) # 'C' .OR. Empty(cRegQuery)
    DC_WinAlert('Could not register RMChart OCX')
  ENDIF
ENDIF

* --- RMChart ActiveX Control --
@ 0,0 DCRMCHART oRmChart SIZE 1200, 800 RESIZE DCGUI_RESIZE_RESIZEONLY

* --- Bar Group (1) ---
DcAddBarGroup TO aBarGroup DATA { 20,40,60 } TYPE RMC_BARGROUP COLOR CornflowerBlue
DcAddBarGroup TO aBarGroup DATA { 10,50,70 } TYPE RMC_BARGROUP COLOR Gold

DcAddDataAxis TO aDataAxis1 LABELTEXT { '0','50','100'}

@ 5,5 DcChartRegion oRegion1 ;
   PARENT oRMChart ;
   FOOTER "(c) Copyright - Donnay Software Designs (2008)" ;
   SIZE 350, 350 PIXEL ;
   CAPTION TITLE 'Bar Group Test' ;
   GRID ;
   LEGEND TEXT { 'This Year', 'Last Year' } ;
   DATAAXIS aDataAxis1 ;
   LABELAXIS LABELARRAY { 'Apples','Peaches','Bananas' } ;
   BARGROUP aBarGroup

* --- Line Group (2) ---

DcAddLineGroup TO aLineGroup DATA { 20,40,60 } COLOR CornflowerBlue
DcAddLineGroup TO aLineGroup DATA { 10,50,70 } COLOR Gold

@ 5,400 DcChartRegion oRegion2 ;
   PARENT oRMChart ;
   FOOTER "(c) Copyright - Donnay Software Designs (2008)" ;
   SIZE 350, 350 PIXEL ;
   CAPTION TITLE 'Line Group Test' ;
   GRID ;
   LEGEND TEXT { 'This Year', 'Last Year' } ;
   DATAAXIS aDataAxis1 ;
   LABELAXIS LABELARRAY { 'Apples','Peaches','Bananas' } ;
   LINEGROUP aLineGroup

* --- Donut (3) ---
DcAddGridlessGroup TO aDonut DATA { 20,40,60 } ;
   COLOR { Red, Yellow, Green } STYLE RMC_DONUT_3D

@ 400,5 DcChartRegion oRegion3 ;
   PARENT oRMChart ;
   FOOTER "(c) Copyright - Donnay Software Designs (2008)" ;
   SIZE 200, 350 ;
   CAPTION TITLE 'Donut Test' ;
   LEGEND TEXT { 'Apples', 'Peaches', 'Bananas' } ;
   GRIDLESSGROUP aDonut

* --- Pie (4) ---
DcAddGridlessGroup TO aPie DATA { 20,40,60 } ;
   COLOR { Gold, Silver, SteelBlue } STYLE RMC_PIE_3D

@ 400,250 DcChartRegion oRegion4 ;
   PARENT oRMChart ;
   FOOTER "(c) Copyright - Donnay Software Designs (2008)" ;
   SIZE 200, 350 ;
   CAPTION TITLE 'Pie Test' ;
   LEGEND TEXT { 'Apples', 'Peaches', 'Bananas' } ;
   GRIDLESSGROUP aPie

* --- Floating Bars (5) ---
DcAddBarGroup TO aBarGroupFloat DATA { 20,20,40,10,60,30 } ;
   TYPE RMC_FLOATINGBARGROUP COLOR CornflowerBlue HORIZONTAL ;
   STYLE RMC_BAR_HOVER

DcAddBarGroup TO aBarGroupFloat DATA { 10,30,50,10,70,20 } ;
   TYPE RMC_FLOATINGBARGROUP COLOR Gold HORIZONTAL ;
   STYLE RMC_BAR_HOVER

DcAddDataAxis TO aDataAxis5 ;
   LABELTEXT { 'Week 1','Week 2','Week 3','Week 4','Week 5','Week 6'} ;
   ALIGN RMC_DATAAXISBOTTOM ;

@ 5,800 DcChartRegion oRegion5 ;
   PARENT oRMChart ;
   FOOTER "(c) Copyright - Donnay Software Designs (2008)" ;
   SIZE 350, 350 PIXEL ;
   CAPTION TITLE 'Floating Bar Group Test' ;
   GRID ;
   LEGEND TEXT { 'This Year', 'Last Year' } ;
   DATAAXIS aDataAxis5 ;
   LABELAXIS LABELARRAY { 'Apples','Peaches','Bananas' } ALIGN RMC_LABELAXISLEFT ;
   BARGROUP aBarGroupFloat

* --- Bar and Line (6) ---


DcAddBarGroup TO aBarGroupIndus ;
   DATA { 242365,235598,232571,185524,170457,164196,149321,132797,130067,119703 } ;
   TYPE RMC_BARSINGLE COLOR Gold ;
   STYLE RMC_BAR_FLAT_GRADIENT2 ;
   WHICHDATAAXIS 1

DcAddLineGroup TO aLineGroupIndus ;
   DATA { 8.9, 4.1, 4.4, 2.1, .3, .3, 5.9, 11.3, 6.7, 6 } ;
   WHICHDATAAXIS 2 ;
   STYLE RMC_LINE_CABLE ;
   COLOR Green ;
   LINESTYLE RMC_LSTYLE_LINE ;
   SYMBOLSTYLE RMC_SYMBOL_BULLET ;
   VALUELABEL 1

DcAddDataAxis TO aDataAxis6 ;
   AXISTEXT "Total Turnover in Million $"  ;
   ALIGN RMC_DATAAXISLEFT  ;
   MINVALUE 100000 MAXVALUE 250000 ;
   TICKCOUNT 11 FONTSIZE 9 ;
   TEXTCOLOR Black LINECOLOR Black ;
   LINESTYLE RMC_LINESTYLESOLID ;
   DECDIGITS 0 UNIT '$'

DcAddDataAxis TO aDataAxis6 ;
   AXISTEXT "Net Operating Margin"  ;
   ALIGN RMC_DATAAXISRIGHT ;
   TEXTCOLOR Black LINECOLOR Black ;
   MINVALUE 0 MAXVALUE 0 ;
   DECDIGITS 2 UNIT " %"

aLabelText := { "Exxon Mobil", "Royal Dutch / Shell","BP", "General Motors", ;
                "Daimler Chrysler", "Ford Motor", "Toyota Motor", "General Electric", ;
                "TOTAL","Chevron Texaco" }

@ 400,500 DcChartRegion oRegion6 ;
   PARENT oRMChart ;
   SIZE 650, 350 PIXEL ;
   CAPTION TITLE 'Bar and Line Test' BACKCOLOR Coral TEXTCOLOR FloralWhite FONTSIZE 10 BOLD ;
   GRID ;
   DATAAXIS aDataAxis6 ;
   LABELAXIS LABELARRAY aLabelText ALIGN RMC_LABELAXISBOTTOM ;
   BARGROUP aBarGroupIndus ;
   LINEGROUP aLineGroupIndus


@ 805,0 DCPUSHBUTTON CAPTION {||'Mouse Tip ' + IIF(oRMChart:toolTipEnable,'OFF','ON')} ;
    SIZE 100,20 ACTION {||oRMChart:toolTipEnable := !oRMChart:toolTipEnable, ;
                          DC_GetRefresh(GetList), ;
                          oRMChart:showToolTip(-1)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save Chart to RMC File' SIZE 130,20 ;
   ACTION {||SaveChartToFile(oRMChart),DC_GetRefresh(GetList)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save Chart to Bitmap' SIZE 140,20 ;
   ACTION {||SaveChartToBitmap(oRMChart)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Save Chart to ClipBoard' SIZE 140,20 ;
   ACTION {||SaveChartToClipboard(oRMChart)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Create New Chart from RMC' SIZE 140,20 ;
   TOOLTIP 'Open a new window and create chart from DCCHART.RMC' ;
   ACTION {||CreateChartFromRMC()} WHEN {||Fexists('DCCHART.RMC')}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Load RMC into this Chart' SIZE 140,20 ;
   TOOLTIP 'Load a selected *.RMC file into this Window' ;
   ACTION {||LoadChartFromRMC(oRMChart)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Apply New Data' SIZE 90,20 ;
   TOOLTIP 'Apply new RANDOM data to all graph regions' ;
   ACTION {||ApplyNewData1(oRMChart:regions[1]), ;
             ApplyNewData2(oRMChart:regions[2]), ;
             ApplyNewData4(oRMChart:regions[3]), ;
             ApplyNewData4(oRMChart:regions[4]), ;
             ApplyNewData6(oRMChart:regions[6]), ;
             oRMChart:draw()}


@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Computer Fairs' SIZE 90,20 ;
   TOOLTIP 'Make a new graph from "Computer Fairs.RMC"' ;
   ACTION {||ComputerFairs()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'eXpress++ Sales' SIZE 90,20 ;
   TOOLTIP 'Make a new graph from "eXpress.RMC"' ;
   ACTION {||ExpressSales()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Print' SIZE 50,20 ;
   ACTION {||PrintChart(oRMChart)}

DCGETOPTIONS RESIZE PIXEL

DCREAD GUI ;
    SETAPPWINDOW ;
    FIT ;
    TITLE 'DCRMCHART Sample Program' ;
    OPTIONS GetOptions ;
    EVAL {||oRMChart:RMCToolTipWidth := 100, ;
            oRMChart:RMCUserWatermark := 'eXpress++ RMChart System', ;
            oRMChart:RMCUserWMAlignment := RMC_TEXTRIGHT, ;
            oRMChart:RMCUserWMFontSize := 32, ;
            oRMChart:RMCUserWMLucent := 40, ;
            oRmChart:mouseDown := ;
            {|a,b,c,d,e,o|wtf e,  aData := e,nWhich := a,o:=Thread():new(),o:start({||BrowseCallbackData(nWhich,aData,oRMChart)})}, ;
            oRmChart:mouseMove := ;
            {|nMouseButton,b,nX,nY,aData|oRMChart:showToolTip( nMouseButton, nX, nY, aData )}, ;
            oRmChart:draw() }

RETURN nil

* --------------

STATIC FUNCTION ApplyNewData1( oRegion )

LOCAL i, aBarData1[0], aBarData2[0]

FOR i := 1 TO 3
  Sleep(2)
  AAdd(aBarData1,DC_Random(100))
  Sleep(2)
  AAdd(aBarData2,DC_Random(100))
NEXT

oRegion:barGroup[1,DCRMCHART_BARSERIES_DATA] := aBarData1
oRegion:barGroup[2,DCRMCHART_BARSERIES_DATA] := aBarData2
oRegion:reset()

RETURN nil

* --------------

STATIC FUNCTION ApplyNewData2( oRegion )

LOCAL i, aLineData1[0], aLineData2[0]

FOR i := 1 TO 3
  Sleep(2)
  AAdd(aLineData1,DC_Random(100))
  Sleep(2)
  AAdd(aLineData2,DC_Random(100))
NEXT

oRegion:lineGroup[1,DCRMCHART_LINESERIES_DATA] := aLineData1
oRegion:lineGroup[2,DCRMCHART_LINESERIES_DATA] := aLineData2
oRegion:reset()

RETURN nil

* --------------

STATIC FUNCTION ApplyNewData4( oRegion )

LOCAL i, aPieData[0]

FOR i := 1 TO 3
  Sleep(2)
  AAdd(aPieData,DC_Random(100))
NEXT

oRegion:gridlessGroup[1,DCRMCHART_GRIDLESSSERIES_DATA] := aPieData
oRegion:reset()

RETURN nil


* --------------

STATIC FUNCTION ApplyNewData6( oRegion )

LOCAL i, aBarData[0], aLineData[0]

FOR i := 1 TO 10
  Sleep(2)
  AAdd(aBarData,(DC_Random(255)*1000)+DC_Random(255))
NEXT

FOR i := 1 TO 10
  Sleep(2)
  AAdd(aLineData,(DC_Random(25)+(DC_Random(10)*.1)))
NEXT

oRegion:barGroup[1,DCRMCHART_BARSERIES_DATA] := aBarData
oRegion:dataAxis[1,DCRMCHART_DATAAXIS_MINVALUE] := 10000
oRegion:dataAxis[1,DCRMCHART_DATAAXIS_MAXVALUE] := 300000
oRegion:lineGroup[1,DCRMCHART_LINESERIES_DATA] := aLineData
oRegion:reset()

RETURN nil

* --------------

STATIC FUNCTION ShowDebugInfo( oRMChart )

//wtf oRMChart:Region(1):BarSeries(1)

RETURN nil

* --------------

PROC appsys
RETURN

* --------------

STATIC FUNCTION BrowseCallbackData( nWhich, aData, oRMChart )

LOCAL GetList[0], oBrowse, nRegion

IF nWhich == 1 // left mouse button

  @ 0,0 DCBROWSE oBrowse DATA aData SIZE 30,37 NOHSCROLL FIT ;
        PRESENTATION DC_BrowPres() FONT '10.Lucida Console'

  DCBROWSECOL DATA {||oBrowse:arrayElement} HEADER 'Element' WIDTH 5 PICTURE '99' PARENT oBrowse
  DCBROWSECOL ELEMENT 1 HEADER 'Desc' WIDTH 20 PARENT oBrowse
  DCBROWSECOL ELEMENT 2 HEADER 'Data' WIDTH 15 PARENT oBrowse PICTURE '999999999.99'

  DCREAD GUI FIT ADDBUTTONS TITLE 'RMChart Mouse Data'

ELSEIF nWhich == 2 // right mouse button

  nRegion := aData[5,2]
  IF nRegion > 0
    DC_InspectObject( oRMChart:regions[nRegion] )
  ENDIF

ENDIF

RETURN nil

* -------------

STATIC FUNCTION SaveChartToFile( oRMChart )

LOCAL cFileName := DC_Path(AppName(.t.)) + 'DCCHART.RMC'
oRMChart:writeRMCFile( cFileName )
DCMSGBOX 'Chart saved to: ' + cFileName TIMEOUT 3

RETURN nil

* -------------

STATIC FUNCTION SaveChartToBitmap( oRMChart )

LOCAL cFileName := DC_Path(AppName(.t.)) + 'DCCHART.JPG'
oRMChart:draw2File( cFileName )
DCMSGBOX 'Chart saved to: ' + cFileName TIMEOUT 3
DC_SpawnUrl( cFileName )

RETURN nil

* -------------

STATIC FUNCTION SaveChartToClipboard( oRMChart )

oRMChart:draw2ClipBoard()
DCMSGBOX 'Chart saved to ClipBoard' TIMEOUT 3

RETURN nil

* -------------

STATIC FUNCTION LoadChartFromRMC( oRMChart )

LOCAL GetList[0], cFileName := Space(50), lStatus

@ 0,0 DCSAY 'RMC File Name:' SAYSIZE 0
@ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c)} ;
   VALID {||DC_ReadEmpty(cFileName)}

DCREAD GUI FIT TITLE 'Load RMC File into Chart' ;
   TO lStatus MODAL ADDBUTTONS

IF lStatus
  oRMChart:RMCFile := Alltrim(cFileName)
  oRMChart:draw()
  oRMChart:mouseMove := {||nil}
  oRMChart:mouseDown := {||nil}
ENDIF

RETURN nil

* -------------

STATIC FUNCTION CreateChartFromRMC()

LOCAL GetList[0], oRMChart

* --- RMChart ActiveX Control --
@ 0,0 DCRMCHART oRmChart SIZE 1200, 800 RESIZE DCGUI_RESIZE_RESIZEONLY PIXEL

DCREAD GUI FIT TITLE 'RMChart created from an RMC File' ;
   EVAL {||LoadRMCFile(oRMChart)} MODAL

RETURN nil

* -------------

STATIC FUNCTION LoadRMCFile( oRMChart )

LOCAL cFileName := DC_Path(AppName(.t.)) + 'DCCHART.RMC'

oRMChart:RMCFile := cFileName
oRMChart:draw()

RETURN nil

* -------------

STATIC FUNCTION ComputerFairs()

LOCAL GetList[0], GetOptions, oRMChart

* --- RMChart ActiveX Control --
@ 0,0 DCRMCHART oRmChart SIZE 600, 500 RESIZE DCGUI_RESIZE_RESIZEONLY PIXEL

@ 520, 0 DCPUSHBUTTON CAPTION 'Apply Random Data' ;
         SIZE 120,20 PIXEL ACTION {||ApplyCFRandomData(oRMChart)}

@ 550,0 DCSAY 'This graph was created with the RMCDesigner.  Click on "Apply Random Data" to apply new data' SAYSIZE 0 PIXEL

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'RMChart created from "Computer Fairs.RMC" File' ;
   EVAL {||oRmChart:RMCFile := "Computer Fairs.RMC", oRMChart:draw()} MODAL ;
   OPTIONS GetOptions

RETURN nil

* ------------

STATIC FUNCTION ApplyCFRandomData( oRMChart )

LOCAL i, aData[0], aNames, aData1[0], aNames1[0], aColors[0], nColor

aNames := { 'Xbase++ Devcon', 'eXpress++ Devcon', 'Clipper World', 'CES, Las Vegas', 'Middleton Fair', ;
            'Cebit, Hannover', 'Infocomm, USA', 'IFA, Berlin', 'Simo, Madrid', 'Networld, Las Vegas' }

FOR i := 1 TO 10
  Sleep(2)
  AAdd(aData,{DC_Random(255)*20.5,aNames[i]} )
NEXT

ASort( aData,,,{|a,b|a[1]>b[1]})

FOR i := 1 TO Len(aData)
  AAdd(aData1,aData[i,1])
  AAdd(aNames1,aData[i,2])
  IF aData[i,1] > 3000
    nColor := IndianRed
  ELSEIF aData[i,1] > 2000
    nColor := DarkTurquoise
  ELSEIF aData[i,1] > 1000
    nColor := AutumnOrange
  ELSE
    nColor := DarkOrchid
  ENDIF
  AAdd( aColors, nColor )
NEXT

oRMChart:applyData( aData1 )
oRMChart:applyLabelAxis( aNames1 )
oRMChart:applyColors( aColors )
oRMChart:draw()

RETURN nil


* -------------

STATIC FUNCTION ExpressSales()

LOCAL GetList[0], GetOptions, oRMChart

* --- RMChart ActiveX Control --
@ 0,0 DCRMCHART oRmChart SIZE 600, 470 RESIZE DCGUI_RESIZE_RESIZEONLY PIXEL

@ 480, 0 DCPUSHBUTTON CAPTION 'Apply Random Data' ;
         SIZE 120,20 PIXEL ACTION {||ApplyEXRandomData(oRMChart)}

@ 510,0 DCSAY 'This graph was created with the RMCDesigner.  Click on "Apply Random Data" to apply new data' SAYSIZE 0 PIXEL

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'RMChart created from "eXPress.RMC" File' ;
   EVAL {||oRmChart:RMCFile := "eXpress.RMC", oRMChart:draw()} MODAL ;
   OPTIONS GetOptions

RETURN nil

* ------------

STATIC FUNCTION ApplyEXRandomData( oRMChart )

LOCAL i, aData1[0], aData2[0]

FOR i := 1 TO 12
  Sleep(2)
  AAdd(aData1,DC_Random(100) )
  Sleep(2)
  AAdd(aData2,DC_Random(100) )
NEXT

oRMChart:applyData( aData1,,,1 )
oRMChart:applyData( aData2,,,2 )

oRMChart:draw()

RETURN nil

* ------------

STATIC FUNCTION PrintChart( oRMChart )

oRMChart:draw2Printer(2)

RETURN nil

